import es
import playerlib
import popuplib
import effectlib
import cfglib
import urllib2
import random
import gamethread
import usermsg
import vecmath
import ConfigParser

#AddonInfo:
info = es.AddonInfo() 
info.name     	= "Assassination" 
info.basename 	= "assassination"
info.version  	= "v1.0"
info.url      	= "www.NextGenerationGaming.de" 
info.description = "Assassination gamemode from older Counter-Strike versions."
info.author   	= "Ruuubi"

#Globals:
pathAddon = es.getAddonPath("assassination")

#Lists:
downloadList = []

#Config:
es.ServerVar('as_admins','','')
es.ServerVar('as_commands','!as;!asadmin','')
DISABLE_SPE = es.ServerVar('as_disable_spe',0,'')
DRAW_ZONE =  es.ServerVar('as_draw_escapezone',0,'')

VIP_MODEL = str(es.ServerVar('as_vip_model','player/vad36gtav/michael',''))
VIP_BLOCK_PICKUP = es.ServerVar('as_vip_block_pickup',1,'')
es.ServerVar('as_vip_spawn_weapons','knife;usp','')
VIP_HEALTH = es.ServerVar('as_vip_health',100,'')
VIP_ARMOR = es.ServerVar('as_vip_armor',200,'')
VIP_AMMO_PRIMARY = es.ServerVar('as_vip_ammo_primary',0,'')
VIP_AMMO_SECONDARY = es.ServerVar('as_vip_ammo_secondary',12,'')
cfglib.AddonCFG(pathAddon+'/configs/config.cfg').execute()

ADMINS = str(es.ServerVar('as_admins')).split(';')
COMMANDS = str(es.ServerVar('as_commands')).split(';')
VIP_SPAWN_WEAPONS = ['weapon_'+s for s in str(es.ServerVar('as_vip_spawn_weapons')).split(';')]

#Downloadlist:
file = open(pathAddon+'/configs/downloadlist.txt','r')
content = file.readlines()
file.close()
for x in content:
	if not x.startswith('//') and x != '\n': downloadList.append(x.rstrip('\n'))

if not DISABLE_SPE:
	try:
		import spe
		from spe import HookType
		from spe import HookAction
		USE_SPE = True
	except: USE_SPE = False
else: USE_SPE = False

class DelayManager(object):
	def __init__(self):
		self.delays = []

	def add(self,name,duration):
		if name in self.delays: gamethread.cancelDelayed(name)
		else: self.delays.append(name)
		gamethread.delayedname(duration,name,self.durationEnd,name)

	def stopAll(self):
		for x in self.delays: gamethread.cancelDelayed(x)

	def durationEnd(self,name):
		if name in self.delays:
			self.delays.remove(name)
			if name == 'tick':
				delay.add('tick',0.1)
				game.tick()
			elif name == 'escapeFailed': game.vipEscapeFailed()
			elif name == 'giveWeaponsToVIP':
				for weapon in VIP_SPAWN_WEAPONS: es.give(game.vip,weapon)
				vipPlayer = playerlib.getPlayer(game.vip)
				if vipPlayer.getPrimary(): vipPlayer.setPrimaryAmmo(VIP_AMMO_PRIMARY)
				if vipPlayer.getSecondary(): vipPlayer.setSecondaryAmmo(VIP_AMMO_SECONDARY)
				game.disableWeaponCheck = False
			

class GameManager(object):
	def __init__(self):
		self.reset()

	def reset(self):
		self.enabled = False
		self.roundRunning = False
		self.vip = None
		self.escapeZone = {'start': None, 'end': None}
		self.drawZone = DRAW_ZONE
		self.checkedWeapons = {}
		self.disableWeaponCheck = True
		
	def setDownloads(self):
		for file in downloadList: es.stringtable('downloadables',file)

	def loadMapData(self):
		self.reset()
		curMap = str(es.ServerVar('eventscripts_currentmap'))
		data = ConfigParser.ConfigParser()
		data.optionxform = str
		data.read(pathAddon+'/database/mapdata.ini')
		for mapname in data.sections():
			if mapname == curMap:
				if 'start' in data.options(mapname): self.escapeZone['start'] = map(int,data.get(mapname,'start').split(','))
				if 'end' in data.options(mapname): self.escapeZone['end'] = map(int,data.get(mapname,'end').split(','))
		if self.escapeZone['start'] != None and self.escapeZone['end'] != None: self.enabled = True

	def checkVersion(self):
		try:
			file = urllib2.urlopen('http://www.nextgenerationgaming.de/addons/assassination/version.txt')
			version = file.readline()
			file.close()
			return version
		except:
			return None

	def setVip(self,userid):
		self.vip = int(userid)
		self.disableWeaponCheck = True
		self.checkedWeapons.clear()
		vipPlayer = playerlib.getPlayer(userid)
		vipPlayer.setModel(VIP_MODEL)
		es.give(self.vip,'player_weaponstrip')
		es.fire(self.vip,'player_weaponstrip','strip')
		delay.add('giveWeaponsToVIP',0.1)
		vipPlayer.health = VIP_HEALTH
		vipPlayer.armor = VIP_ARMOR
		usermsg.hudhint(self.vip,'You are the VIP!\nTry to reach the escape zone!')
		whisper(self.vip,'#greenYou are the VIP! Try to reach the escape zone!')
		for ct in playerlib.getPlayerList('#ct'):
			es.playsound(ct.userid,'radio/vip.wav',1.0)
			if ct.userid != self.vip: whisper(ct.userid,'#greenEscort #blue%s #greento the escape zone!' % es.getplayername(self.vip))
		self.roundRunning = True

	def vipKilled(self):
		if self.roundRunning:
			msg('VIP has been assassinated!')
			self.endround(2)

	def vipEscaped(self):
		if self.roundRunning:
			msg('The VIP has escaped!')
			self.endround(1)

	def vipEscapeFailed(self):
		if self.roundRunning:
			msg('VIP has not escaped!')
			self.endround(14)

	#Taken from EST replacement by fratacos, thanks!
	def endround(self,reason):
		index = es.getentityindex("info_map_parameters")
		created = False
		if index == -1:
			index = es.createentity("info_map_parameters")
			created = True
		userid = es.getuserid()
		if userid:
			es.fire(userid,"info_map_parameters","FireWinCondition",reason)
			if created: es.fire(userid,"info_map_parameters","Kill")

	def tick(self):
		if self.escapeZone['start'] != None and self.escapeZone['end'] != None:
			if self.drawZone: effectlib.drawBox(self.escapeZone['start'],self.escapeZone['end'],red=255,green=128,blue=0,seconds=0.3)
			if self.vip and self.roundRunning:
				if vecmath.isbetweenRect(es.getplayerlocation(self.vip),self.escapeZone['start'],self.escapeZone['end']): self.vipEscaped()

delay = DelayManager()
game = GameManager()

def load():
	es.set('assassination_version',info.version)
	es.makepublic('assassination_version')
	delay.add('tick',0.1)
	game.loadMapData()
	game.setDownloads()
	if USE_SPE and VIP_BLOCK_PICKUP:
		spe.parseINI('assassination/configs/signatures.ini')
		spe.detourFunction("Rebuy",HookType.Pre,preRebuy)
		spe.detourFunction("AutoBuy",HookType.Pre,preAutoBuy)
		spe.detourFunction("BumpWeapon",HookType.Pre,preBumpWeapon)
		es.addons.registerClientCommandFilter(clientCommandFilter)
	msg('#blueAssassination %s #greensuccessfully loaded!' % info.version)

def unload():
	delay.stopAll()
	if USE_SPE:
		spe.undetourFunction("Rebuy",HookType.Pre,preRebuy)
		spe.undetourFunction("AutoBuy",HookType.Pre,preAutoBuy)
		spe.undetourFunction("BumpWeapon",HookType.Pre,preBumpWeapon)
		es.addons.unregisterClientCommandFilter(clientCommandFilter)
	msg('#blueAssassination %s #greensuccessfully unloaded!' % info.version)

def es_map_start(ev):
	game.loadMapData()
	game.setDownloads()

def player_spawn(ev):
	player = playerlib.getPlayer(ev['userid'])
	player.armor = min(player.armor,100)

def player_say(ev):
	userid = int(ev['userid'])
	if ev['text'] in COMMANDS:
		if es.getplayersteamid(userid) in ADMINS:
			playHintSound(userid,1)
			popupOpen(userid)
		else:
			playHintSound(userid,0)
			whisper(userid,'#redYou have no access!')

def player_death(ev):
	if int(ev['userid']) == game.vip: game.vipKilled()

def player_disconnect(ev):
	if int(ev['userid']) == game.vip: game.vipEscapeFailed()

def round_start(ev):
	if game.enabled:
		if es.getplayercount(3) > 0:
			game.setVip(random.choice(playerlib.getPlayerList('#ct')))
			entDict = es.createentitylist()
			for entIndex in entDict:
				if entDict[entIndex]['classname'] == "hostage_entity" or entDict[entIndex]['classname'] == "func_bomb_target": es.server.queuecmd('es_xremove %s' % entIndex)

def round_freeze_end(ev):
	delay.add('escapeFailed',float(es.ServerVar('mp_roundtime'))*60)

def round_end(ev):
	game.vip = None
	game.roundRunning = False

def clientCommandFilter(userid,args):
	command = args[0].lower()
	if userid == game.vip and (command == 'buy' or command == 'drop'): return False
	return True
	
'''
arg0 = Player
'''
def preRebuy(args):
	if getUseridFromPointer(args[0]) == game.vip: return (HookAction.Override,0)
	return (HookAction.Continue,0)

'''
arg0 = Player
'''
def preAutoBuy(args):
	if getUseridFromPointer(args[0]) == game.vip: return (HookAction.Override,0)
	return (HookAction.Continue,0)

'''
arg0 = Weapon
arg1 = Player
'''
def preBumpWeapon(args):
	if game.disableWeaponCheck: return (HookAction.Continue,0)
	if getUseridFromPointer(args[1]) == game.vip:
		if args[0] not in game.checkedWeapons:
			index = spe.getIndexOfEntity(args[0])
			if index:
				if es.entitygetvalue(index,'classname') not in VIP_SPAWN_WEAPONS:
					game.checkedWeapons[args[0]] = 'black'
					return (HookAction.Override,0)
				else:
					game.checkedWeapons[args[0]] = 'white'
		else:
			if game.checkedWeapons[args[0]] == 'black': return (HookAction.Override,0)
	return (HookAction.Continue,0)

def getUseridFromPointer(pointer):
	index = spe.getIndexOfEntity(pointer)
	if index: return es.getuserid(es.gethandlefromindex(index))
	return None

def msg(msg):
	msg = '#black[#blueAS#black] #green%s' % str(msg)
	msg = msg.replace('#black','\x07000000')
	msg = msg.replace('#blue','\x0720B2AA')
	msg = msg.replace('#red','\x07FF3D3D')
	es.msg('#multi',msg)

def whisper(userid,msg):
	msg = '#black[#blueAS#black] #green%s' % str(msg)
	msg = msg.replace('#black','\x07000000')
	msg = msg.replace('#blue','\x0720B2AA')
	msg = msg.replace('#red','\x07FF3D3D')
	es.tell(userid,'#multi',msg)

def popupOpen(userid):
	temp = popuplib.easymenu('asMain',None,popupSelected)
	temp.settitle('Assassination %s' % info.version)
	temp.setdescription('by Ruuubi\n-----------------------------\nMap: %s\nStart: %s\nEnd: %s' % (es.ServerVar('eventscripts_currentmap'),game.escapeZone['start'],game.escapeZone['end']))
	temp.addoption('setStart','[X] Set Start') if game.escapeZone['start'] != None else temp.addoption('setStart','[  ] Set Start')
	temp.addoption('setEnd','[X] Set End') if game.escapeZone['end'] != None else temp.addoption('setEnd','[  ] Set End')
	temp.addoption('hitboxOFF','[X] Draw Zone') if game.drawZone else temp.addoption('hitboxON','[  ] Draw Zone')
	temp.addoption('remove','Remove Location')
	temp.addoption('save','Save & Restart Map')
	temp.addoption('version','Check Version')
	temp.send(userid)
	temp.delete()

def popupSelected(userid,choice,popupname):
	if choice != 'save': playHintSound(userid,1)
	if choice == 'setStart':
		x,y,z = es.getplayerlocation(userid)
		game.escapeZone['start'] = list((int(x),int(y),int(z)))
	elif choice == 'setEnd':
		x,y,z = es.getplayerlocation(userid)
		game.escapeZone['end'] = list((int(x),int(y),int(z)))
	elif choice == 'hitboxON': game.drawZone = True
	elif choice == 'hitboxOFF': game.drawZone = False
	elif choice == 'remove':
		game.escapeZone['start'] = None
		game.escapeZone['end'] = None
		game.enabled = False
	elif choice == 'save':
		if game.escapeZone['start'] != None and game.escapeZone['end'] != None:
			playHintSound(userid,1)
			curMap = str(es.ServerVar('eventscripts_currentmap'))
			iniFile = ConfigParser.RawConfigParser()
			iniFile.read(pathAddon+'/database/mapdata.ini')
			if curMap not in iniFile.sections(): iniFile.add_section(curMap)
			iniFile.set(curMap,'start',','.join(map(str,game.escapeZone['start'])))
			iniFile.set(curMap,'end',','.join(map(str,game.escapeZone['end'])))
			ini = open(pathAddon+'/database/mapdata.ini','wb')
			iniFile.write(ini)
			whisper(userid,'#greenSaving complete!')
			game.enabled = True
			es.server.queuecmd('mp_restartgame 1')
		else:
			playHintSound(userid,0)
			whisper(userid,'#redCan not save escape zone!')
			whisper(userid,'#redAt least one location is not set!')
	elif choice == 'version':
		whisper(userid,'#greenChecking version...')
		latestVersion = game.checkVersion()
		if latestVersion == info.version:
			whisper(userid,'#greenYou have the latest version! (#blue%s#green)' % info.version)
		elif latestVersion == None:
			whisper(userid,"#redVersion check failed!")
			whisper(userid,"#redEither the website is down or your firewall is blocking it!")
		else:
			whisper(userid,'#redYour version differs from the server!')
			whisper(userid,'#greenYour version: #blue%s #green| Latest: #blue%s' % (info.version,latestVersion))
	popupOpen(userid)

def playHintSound(userid,number):
	if number == 0: es.playsound(userid,'buttons/button11.wav',1.0)
	elif number == 1: es.playsound(userid,'UI/buttonclick.wav',1.0)